<?php
/***
    sexybookmarks Vers. 0.1 
    Written on 2011/07/16

    Created by www.raum2projekt.de
    Mail: info[at]raum2projekt[dot]de

    Tested with Redaxo 4.2 und 4.3.2
    Released for free !

	Hinweis:
	Das AddOn "sexybookmarks" kann auf eigenes Risiko beliebig eingesetzt und verndert werden.
	Wir bernehmen keine Haftung fr evtl. Schden, welche durch die Verwendung des Addons entstehen.

	Als Basis fr dieses AddOn wurde das sexybookmarks-Plugin fr wordpress in der Version 4.0.4.2
	verwendet. Details ber das Basisplugin sind in der Hilfe zu finden. Den Entwicklern 
	des BasisPlugins ein groes Dankeschn.
***/

class SexyBookmarksModul {
	
	var $thisFramework;
	
	function SexyBookmarksModul($_this, $_shortDescription='') {
		global $REX;
		$this->thisFramework = $_this;
		$REX['ADDON']['sexybookmarks']['title'] = $this->thisFramework->getValue('name');
		$REX['ADDON']['sexybookmarks']['content'] = $_shortDescription;
	}
	
	function getModulInput() {
		return '';
	}
	
	function getModulOutput() {
		global $REX;
		if(!$REX['REDAXO']) {
			rex_register_extension('OUTPUT_FILTER', 'shrsb_publicStyles');
			rex_register_extension('OUTPUT_FILTER', 'shrsb_publicScripts');
			rex_register_extension('OUTPUT_FILTER', 'shrsb_write_js_params');
			$output = shrsb_position_menu();
			if($output) {
				if($REX['ADDON']['status']['sexybookmarks'] == '1') {
					return $output;
				}
				else {
					return '';
				}
			}
		}
		else {
			// Hier befindet sich der Benutzer im Backend
			$html = 'SexyBookMarks<br>Kurzbeschreibung:<br>'.$REX['ADDON']['sexybookmarks']['content'];
			if(!file_exists('include/addons/sexybookmarks/spritegen/shr-custom-sprite.png') || !file_exists('include/addons/sexybookmarks/spritegen/shr-custom-sprite.css')) {
         		$html .= '<div style="border-radius:4px;-moz-border-radius:4px;-webkit-border-radius:4px;background:#feb1b1;border:1px solid #fe9090;color:#820101;font-size:10pt;font-weight:bold;height:auto;margin:10px 10px 0 0;overflow:hidden;padding:4px 10px 6px;">';
				$html .= 'Information: sexybookmarks wurde neu konfiguriert, es konnten aber nicht alle bentigten Informationen erzeugt werden. Bitte rufen Sie die Konfiguration erneut auf und wiederholen Sie den Speichervorgang oder informieren Sie den Administrator.</div>';
			}
			return $html;
		}
	}
}

function shrsb_write_js_params($params) {
	global $REX, $shrsb_js_params;

  	$output = '';
  	if ($REX['ADDON']['sexybookmarks']['shareaholic-javascript'] == '1') {
    	$output .= '<script type="text/javascript">SHRSB_Settings = ';
    	$output .= json_encode($shrsb_js_params);
    	$output .= '</script>';
  	}
  
  	$params['subject'] = str_replace('</body>', $output.'</body>', $params['subject']);
	return $params['subject'];
}


// Write the <head> code only on pages that the menu is set to display
function shrsb_publicStyles($params) {
	
	global $REX;
	global $shrsb_custom_sprite;

	$surl = '';
	if ($REX['ADDON']['sexybookmarks']['shareaholic-javascript'] != '1') {
     	if($shrsb_custom_sprite != '') {
        	$surl = 'shr-custom-sprite.css';
      	} 
      	else {
        	$surl = 'style.css';
      	}
      	$params['subject'] = str_replace('</head>', '<link rel="stylesheet" href="'.SHRSB_PUBLIC_FILES_DIR_FROM_FRONTEND.'/'.$surl.'" type="text/css"> </head>', $params['subject']);
  	} 
  	else {
    	$position = array_search('shr-comfeed', $REX['ADDON']['sexybookmarks']['bookmark']);
    	if (is_numeric($position)) {
    		// Hier wird das Stylsheet eingefgt ...
    		$params['subject'] = str_replace('</head>', '<link rel="stylesheet" href="'.SHRSB_PUBLIC_FILES_DIR_FROM_FRONTEND.'/comfeed.css" type="text/css"> </head>', $params['subject']);
    	}
	}
	return $params['subject'];
}


function shrsb_publicScripts($params) {
	global $REX, $default_spritegen;
	
	$spritegen = $default_spritegen ? 'spritegen_default' : 'spritegen';
     
    if ($REX['ADDON']['sexybookmarks']['shareaholic-javascript'] == '1') {
    	
    	$dir = SHRSB_PUBLIC_FILES_DIR_FROM_FRONTEND;
    	
$jsExt = <<<JS
<script type="text/javascript">
/* <![CDATA[ */
var SHRSB_Globals = {
	src: "$dir"
};
/* ]]> */
</script>
JS;

    	$infooter = ($REX['ADDON']['sexybookmarks']['scriptInFooter'] == '1')?true:false;
    	
    	$scriptName = 'shareaholic-publishers.min.js';
      	if($REX['ADDON']['sexybookmarks']['doNotIncludeJQuery'] == '1') {
      		// Dann muss dieses JavaScript direkt geladen werden ...
      		$scriptName = 'jquery.shareaholic-publishers-sb.min.js';
      	}
      	
    	if($infooter) {
    		$params['subject'] = str_replace('</body>', $jsExt. '<script src="'.SHRSB_PUBLIC_FILES_DIR_FROM_FRONTEND.'/'.$scriptName.'" type="text/javascript"></script></body>', $params['subject']);
    	}
    	else {
    		$params['subject'] = str_replace('</head>', $jsExt. '<script src="'.SHRSB_PUBLIC_FILES_DIR_FROM_FRONTEND.'/'.$scriptName.'" type="text/javascript"></script></head>', $params['subject']);
    	}
    	if($REX['ADDON']['sexybookmarks']['fbNameSpace'] == '1' && (strpos($params['subject'], 'xmlns:fb="http://www.facebook.com/2008/fbml') === false)) {
    		$params['subject'] = str_replace('<html', '<html xmlns:fb="http://www.facebook.com/2008/fbml"', $params['subject']);	
    	}
    } 
    
    else {
    	// If any javascript dependent options are selected, load the scripts
    	
    	if (($REX['ADDON']['sexybookmarks']['expand'] || 
    	     $REX['ADDON']['sexybookmarks']['autocenter'] || 
    	     $REX['ADDON']['sexybookmarks']['targetopt']=='_blank')) {

        	$surl = 'sexy-bookmarks-public.js';
     	
      		$infooter = ($REX['ADDON']['sexybookmarks']['scriptInFooter'] == '1')?true:false;
    	    if($infooter) {
    			$params['subject'] = str_replace('</body>', '<script src="'.SHRSB_PUBLIC_FILES_DIR_FROM_FRONTEND.'/'.$surl.'" type="text/javascript"></script></body>', $params['subject']);
    		}
    		else {
    			$params['subject'] = str_replace('</head>', '<script src="'.SHRSB_PUBLIC_FILES_DIR_FROM_FRONTEND.'/'.$surl.'" type="text/javascript"></script></head>', $params['subject']);
    		}
    	}
  	}
  
	if(strpos(strtolower($_SERVER['SERVER_NAME']), 'localhost') !== false) { 
	  	if ($REX['ADDON']['sexybookmarks']['perfoption'] == '1' || 
	  	    $REX['ADDON']['sexybookmarks']['perfoption'] == '' && 
	        $REX['ADDON']['sexybookmarks']['shareaholic-javascript'] !== '1'){
	      	//include code
	      	$params['subject'] = str_replace('</head>', '<script src="'.SHRSB_PUBLIC_FILES_DIR_FROM_FRONTEND.'shareaholic-perf.js" type="text/javascript"></script></head>', $params['subject']);
		}	
	}
	
  	return $params['subject'];
}
	
?>