<?php
/***
    sexybookmarks Vers. 0.1 
    Written on 2011/07/16

    Created by www.raum2projekt.de
    Mail: info[at]raum2projekt[dot]de

    Tested with Redaxo 4.2 und 4.3.2
    Released for free !

	Hinweis:
	Das AddOn "sexybookmarks" kann auf eigenes Risiko beliebig eingesetzt und verndert werden.
	Wir bernehmen keine Haftung fr evtl. Schden, welche durch die Verwendung des Addons entstehen.

	Als Basis fr dieses AddOn wurde das sexybookmarks-Plugin fr wordpress in der Version 4.0.4.2
	verwendet. Details ber das Basisplugin sind in der Hilfe zu finden. Den Entwicklern 
	des BasisPlugins ein groes Dankeschn.
***/


function shrsb_preFlight_Checks() {
	global $REX;
	if( ((function_exists('curl_init') && function_exists('curl_exec')) || 
	      function_exists('file_get_contents')) && 
	      (is_dir(SHRSB_PLUGDIR.'spritegen') && 
	      is_writable(SHRSB_PLUGDIR.'spritegen')) && 
	      ((isset($_POST['bookmark']) && 
	      is_array($_POST['bookmark']) && 
	      sizeof($_POST['bookmark']) > 0 ) || 
	      (isset($REX['ADDON']['sexybookmarks']['bookmark']) && 
	      is_array($REX['ADDON']['sexybookmarks']['bookmark']) && 
	      sizeof($REX['ADDON']['sexybookmarks']['bookmark']) > 0 ))) {
		return true;
	}
	else {
		return false;
	}
}


function get_sprite_file($opts, $type) {
	global $REX;

	$shrCustomSpriteName = 'shr-custom-sprite.'.$type; 
	
  	$shrbase = $REX['ADDON']['sexybookmarks']['shrbase']?$REX['ADDON']['sexybookmarks']['shrbase']:'http://www.shareaholic.com';
  	$spritegen = $shrbase.'/api/sprite/?v=1&apikey=8afa39428933be41f8afdb8ea21a495c&imageset=60'.$opts.'&apitype='.$type;
  	$filename = SHRSB_PLUGDIR.'spritegen/'.$shrCustomSpriteName;
  	$content = FALSE;

  	if (!is_writable(SHRSB_PLUGDIR.'spritegen')) {
    	// the spritegen folder isn't writable. Try changing it to writable
      	@chmod(SHRSB_PLUGDIR.'spritegen', 0775);
     	// may or may not work
  	}
  	if ( $type == 'png' ) {
    	$fp_opt = 'rb';
  	}
  	else {
    	$fp_opt = 'r';
  	}

  	if ( $content === FALSE && function_exists('curl_init') && function_exists('curl_exec') ) {
		$ch = curl_init();
    	curl_setopt($ch, CURLOPT_URL, $spritegen);
    	curl_setopt($ch, CURLOPT_FAILONERROR, TRUE);
    	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
    	curl_setopt($ch, CURLOPT_TIMEOUT, 6);
   		curl_setopt($ch, CURLOPT_USERAGENT, "shr-spritebot-cURL/v" . SHRSB_vNum);
    	curl_setopt($ch, CURLOPT_HEADER, FALSE);
    	curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
    	curl_setopt($ch, CURLOPT_BINARYTRANSFER, TRUE);
    	$content = curl_exec($ch);

    	if ( curl_errno($ch) != 0 ) {
      		$content = FALSE;
   		}
    	curl_close($ch);
  	}

  	// echo $content;
  	if ( $content !== FALSE ) {
    	if ( $type == 'png' ) {
      		$fp_opt = 'w+b';
    	}
    	else {
      		$fp_opt = 'w+';
    	}

    	$fp = @fopen($filename, $fp_opt);

    	
    	if($type != 'png' && $REX['ADDON']['sexybookmarks']['bgimg'] == 'custom') {
    		$content .= "div.shr-bookmarks-bg-custom{padding:".$REX['ADDON']['sexybookmarks']['bgimg_custom_padding']." !important;background:transparent url('../../".$REX['ADDON']['sexybookmarks']['bgimgCustom']."') no-repeat !important}";
    	}
    	$content = str_replace('../images/', '', $content);
    	
    	
    	if ( $fp !== FALSE ) {
      		$ret = @fwrite($fp, $content);
      		@fclose($fp);
      		
    	}
    	else {
    		$ret = @file_put_contents($filename, $content);
    	}

    	if ( $ret !== FALSE ) {
      		@chmod($filename, 0666);
      		// Wenn das hier aufgerufen wird dann ist alles okay:
      		// Jetzt kann die Datei umkopiert werden.
      		// Anpassung fr Redaxo --> Die Datei wird in den ffentlichen
      		// Bereich geschoben.
      		if(!copy($filename, SHRSB_PUBLIC_FILES_DIR.$shrCustomSpriteName)) {
      			return 1;
      		}
      		return 0;
    	}
    	else {
      		return 1;
    	}
  	}
  	else {
    	return 2;
  	}
}


/**
 * Gets the contents of a url on www.shareaholic.com.  We use shrbase as the
 * URL base path.  The caller is responsible for keeping track of whether the
 * cache is up-to-date or not.  If the cache is stale (because some argument
 * has changed), then the caller should pass true as the second argument.
 *
 * @url        - the partial url without base.  ex. /publishers
 * @path       - path to cache result to, under spritegen.
 *               ex. /publishers.html
 *               pass null to use the path part of url
 * @clearcache - force call and overwrite cache.
 */
function _shrsb_fetch_content($url, $path, $clearcache=false, $fileName='') {
	global $REX;
	
	$shrbase = $REX['ADDON']['sexybookmarks']['shrbase']?$REX['ADDON']['sexybookmarks']['shrbase']:'http://www.shareaholic.com';

  	if (!preg_match('|^/|', $url)) {
    	@error_log("url must start with '/' in _shrsb_fetch_content");
    	return FALSE;
  	}
  	
  	// default path
  	if (null === $path) {
    	$url_parts = explode('?', $url);
    	$path = rtrim($url_parts[0], '/');
  	}

  	// Die Funktion wurde aus Wordpress kopiert
  	$base_path = path_join(SHRSB_PLUGDIR, 'spritegen');
  	
  	$abs_path = $base_path.$path;
	$retval = '';
  	
  	if ($clearcache || !($retval = _shrsb_read_file($abs_path))) {  		
  		
    	// Hier muss ich mir noch was berlegen ....
  		$response = sexybookmarks_http_get($shrbase.$url);
		if($response == false) { 
      		@error_log("Failed to fetch ".$shrbase.$url);
      		$retval = FALSE;
    	} 
    	else {
			$writeSuccee = _shrsb_write_file($abs_path, $response);
			if(!$writeSuccee) {
				return FALSE;
			}
			
			// Anpassung fr Redaxo, die Datei muss in den ffentlichen
			// files-Ordner kopiert werden
			if($fileName != '') {
    			if(!copy($abs_path, SHRSB_PUBLIC_FILES_DIR.$fileName)) {
      				return FALSE;
      			}
			}
    	}
  	}

  	return $retval;
}


function _shrsb_write_file($path, $content) {
	$dir = dirname($path);
	$return = false;
	if(!redaxo_mkdir_p(dirname($path))) {
    	@error_log("Fehler beim Erstellen des Pfades ".dirname($path));
  	}
  	$fh = fopen($path, 'w+');
  	if (!$fh) {
    	@error_log("Fehler beim ffnen von ".$path);
  	} 
  	else {
    	if (!fwrite($fh, $content)) {
      		@error_log("Fehler beim Schreiben nach ".$path);
    	}
    	else {
    		$return = true;
    	}
    	@fclose($fh);
  	}
  	return $return;
}


function _shrsb_read_file($path) {
	$content = FALSE;
  	$fh = @fopen($path, 'r');
  	if (!$fh) {
    	@error_log("Fehler beim ffnen von ".$path);
  	} 
  	else {
    	if (!$content = fread($fh, filesize($path))) {
      		@error_log("Fehler beim Schreiben nach ".$path);
    	}
    	@fclose($fh);
  	}
  	return $content;
}

function _make_params($params) {
	$pairs = array();
  	foreach ($params as $k => $v) {
    	$pairs[] = implode('=', array(urlencode($k), urlencode($v)));
  	}
  	return implode('&', $pairs);
}


function get_bloginfo($i) {
	global $REX;
	return $r['host'] = $REX['SERVER'];
}


function sexybookmarks_http_get($url) {
    $url_stuff = parse_url($url);
    $port = isset($url_stuff['port']) ? $url_stuff['port'] : 80;
    $fp = fsockopen($url_stuff['host'], $port);
    if($fp) {
    	$query  = 'GET ' . $url_stuff['path'] . '?' . $url_stuff['query'] . " HTTP/1.0\n";
    	$query .= 'Host: ' . $url_stuff['host'];
    	$query .= "\n\n";
    	$result = fwrite($fp, $query);
    	if($result) {
    		while ($tmp = fread($fp, 1024)) {
        		$buffer .= $tmp;
    		}
    		// In $part[1] befindet sich anschlieend die Contentlnge
    		preg_match('/Content-Length: ([0-9]+)/', $buffer, $parts);
    		if(isset($parts[1]) && $parts[1] > 0) {
    			return substr($buffer, strlen($buffer)-$parts[1]);
    		}
    		else {
    			// Beim png wird keine Contentlnge bergeben ...
    			$parts = preg_split('/Content-Type: image\/png/', $buffer, -1);
    			if(isset($parts[1])) {
    				return trim($parts[1]);
    			}
    			else {
    				return $buffer;
    			}
    		}
    	}
    	return false;
    }
    return false;
}


function createSaveContent($_array, $_startString, $_withSlashN=true) {
	$content = '';
	foreach($_array as $key => $value) {
		if($key !== 'SUBPAGES') {
			if(is_array($value)) {
				$content .= createSaveContent($value, $_startString."['".$key."']");
			}
			else {
				if($_withSlashN) {
					$content .= $_startString."['".$key."'] = '".$value."';\n"; 
				}
				else {
					$content .= $_startString."['".$key."'] = '".$value."';"; 
				}
			}
		}
	}
	return $content;
}



/**
 * Make a local copy of all shareaholic resources
 * Wird nur aufgerufen, wenn die neue API (javascript) eingeschaltet ist
 */
function shrsb_refresh_cache() {
	global $REX, $shrsb_bgimg_map;

  	$script = _shrsb_fetch_content('/media/js/jquery.shareaholic-publishers-sb.min.js', '/jquery.shareaholic-publishers-sb.min.js', true, 'jquery.shareaholic-publishers-sb.min.js');

  	// Sort services to make request more cacheable.
  	$services = explode(',', $REX['ADDON']['sexybookmarks']['service']);
  	sort($services, SORT_NUMERIC);
  	$services = implode(',', $services);

  	$sprite_opts = array(
    	'v' => 2,
    	'apikey' => $REX['ADDON']['sexybookmarks']['apikey'],
    	'service' => $services,
    	'bgimg' => $shrsb_bgimg_map[$REX['ADDON']['sexybookmarks']['bgimg']]['url'],
    	'bgimg_padding' => $shrsb_bgimg_map[$REX['ADDON']['sexybookmarks']['bgimg']]['padding']
  	);
  	
  	// save as css so mime types work on normal servers
  	$css = _shrsb_fetch_content('/api/sprite/?'._make_params($sprite_opts), '/sprite.css', true, 'sprite.css');
  	$sprite_opts['apitype'] = 'png';
  	$png = _shrsb_fetch_content('/api/sprite/?'._make_params($sprite_opts), '/sprite.png', true, 'sprite.png');
  	
	if(!$script || !$css || !$png) {
    	$default_spritegen = true;
  	} else {
    	$REX['ADDON']['sexybookmarks']['SHRSB_DefaultSprite'] = false;
    	$default_spritegen = false;
  	}
}




// Die beiden Funktionen wurden von Wordpress kopiert ...
/**
 * Join two filesystem paths together (e.g. 'give me $path relative to $base').
 *
 * If the $path is absolute, then it the full path is returned.
 *
 * @since 2.5.0
 *
 * @param string $base
 * @param string $path
 * @return string The path with the base or absolute path.
 */
function path_join( $base, $path ) {
	if ( path_is_absolute($path) ) {
		return $path;
	}
	return rtrim($base, '/') . '/' . ltrim($path, '/');
}

/**
 * Test if a give filesystem path is absolute ('/foo/bar', 'c:\windows').
 *
 * @since 2.5.0
 *
 * @param string $path File path
 * @return bool True if path is absolute, false is not absolute.
 */
function path_is_absolute( $path ) {
	// this is definitive if true but fails if $path does not exist or contains a symbolic link
	if ( realpath($path) == $path ) {
		return true;
	}

	if ( strlen($path) == 0 || $path[0] == '.' ) {
		return false;
	}

	// windows allows absolute paths like this
	if ( preg_match('#^[a-zA-Z]:\\\\#', $path) ) {
		return true;
	}
	
	// a path starting with / or \ is absolute; anything else is relative
	return (bool) preg_match('#^[/\\\\]#', $path);
}


// This function based on wp_mkdir_p from wordpress
function redaxo_mkdir_p( $path ) {
	$path = str_replace( '//', '/', $path );
	$path = rtrim($path, '/');
	if ( empty($path) ) {
		$path = '/';
	}
	if ( file_exists( $path ) ) {
		return @is_dir( $path );
	}
	if ( @mkdir( $path ) ) {
		$stat = @stat( dirname( $path ) );
		$dir_perms = $stat['mode'] & 0007777;
		@chmod( $path, $dir_perms );
		return true;
	} elseif ( is_dir( dirname( $path ) ) ) {
		return false;
	}
	if ( ( $path != '/' ) && ( redaxo_mkdir_p( dirname( $path ) ) ) ) {
		return redaxo_mkdir_p( $path );
	}
	return false;
}


// Hilffunktionen fr die Anpassung an Redaxo
function __($s1, $s2="") {
	return $s1;
}

function _e($s1, $s2="") {
	echo $s1;
}



